import java.awt.*;
import java.applet.Applet;

public class CTask extends Panel
  {
    private int teradenrij;
    private int teradenkolom;
    private String teradenveld;
    private Button knopgiveup, knopnewtask;
    CCanvas thecanvas;
    private boolean done;
    private Label task1,task2;
    private Panel taskpanel;
    private Label who;

    private Panel knoppen;

    public int lastclickedrow;
    public int lastclickedcolumn;

    CTask()
    {
      initlabels();
      zettaak1();
    }

    void zettaak()
    { 
      zettaak1();
      repaint();
      thecanvas.repaint();
    }

    void zettaak1()
    {
      teradenrij   = (int) (Math.random() * 8) ;
      teradenkolom = (int) (Math.random() * 8) ;
      lastclickedrow = -1;
      lastclickedcolumn = -1;
      teradenveld  = squarename (teradenrij, teradenkolom);
      task1.setText ("Try to click on square " + teradenveld +".");
      task2.setText ("");
      done = false;
    }

    // speler geeft het op.
    void giveup()
    {
      task1.setText ("Square " + teradenveld + " is now colored red.");
      task2.setText ("Click New square for another square.");
      // we doen net of het laatste geklikte veld het goede was.
      lastclickedrow = teradenrij;
      lastclickedcolumn = teradenkolom;
      done = true;
      thecanvas.repaint();
      repaint();
    }

    public void geklikt (int row, int column)
    {
      if (done == false)
      {
	lastclickedrow = row;
	lastclickedcolumn = column;
	if (row == teradenrij && column == teradenkolom )
	{
	  task1.setText ("Well done! You clicked on " + teradenveld
			+ " correctly!");
          task2.setText ("Click New Square for another square.");

          done = true;
        }
	else
	{
	  String gekliktveld = squarename (row, column);
	  task1.setText ("Try to click on " + teradenveld +".");
	  task2.setText ("Sorry! You clicked on " + gekliktveld +".");
        }
	thecanvas.repaint();
	repaint();
      }
    }

    void initlabels()
    {
       task1 = new Label("");
       task2 = new Label("");
       taskpanel = new Panel();
       taskpanel.setLayout( new BorderLayout());
       taskpanel.add("Center",task1);
       taskpanel.add("South",task2);

       who = new Label("Applet made by Hans Bodlaender, 1997");
       knopgiveup = new Button ("Giveup");
       knopnewtask = new Button ("New Square");

       knoppen = new Panel();
       knoppen.add(knopgiveup);
       knoppen.add(knopnewtask);

       setLayout( new BorderLayout());
       add ("North", knoppen);
       add ("Center",taskpanel);
       add ("South", who);
    }

    public boolean action (Event e, Object o)
    {
      if ( (e.target instanceof Button) && (e.target == knopgiveup))
      { 
	if (done == false)
	{ giveup(); return true; }
      }

      if ((e.target instanceof Button) && (e.target == knopnewtask))
      { 
	zettaak();
      }
      return true;
    }

    public static String squarename (int x, int y)
    {
      char kolom = (char) ('a' + x);
      char rij = (char)('1' + y);
      return (""+kolom + rij);
    }
}
